#!/usr/bin/env python

# Copyright (C) 2002 Jrg Lehmann <joerg@luga.de>
#
# This file is part of PyTone (http://www.luga.de/pytone/)
#
# PyTone is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# PyTone is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PyX; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import curses
import curses.ascii

import config
import help
import window
import events

def generatedescription(section, name):
    keyname = help.keynames[config.keybindings[section][name][0]]
    
    # save some space
    if keyname.startswith("<") and keyname.endswith(">"):
        keyname = keyname[1:-1]

    return [(keyname, _colors["key"]),
            (":"+help.descriptions[section][name][0],
             _colors["description"])]


class statusbar(window.window):
    def __init__(self, screen, line, width, colors, channel):
        self.channel = channel
        self.content = []
        window.window.__init__(self, screen,
                               1, width, line, 0,
                               colors,
                               None)
        self.channel.subscribe(events.updatestatusbar, self.updatestatusbar)

        # hack to export some properties of the statusbar singleton into
        # the module namespace
        global separator
        if width<=80:
            separator = [(" ", self.colors["background"])]
        else:
            separator = [("  ", self.colors["background"])]

        global _colors
        _colors = self.colors

    # event handler

    def updatestatusbar(self, event):
        self.content = event.content
        self.update()

    # update method
    
    def update(self):
        window.window.update(self)
        self.win.move(0,0)
        self.win.clrtoeol()
        
        for element in self.content:
            try:
                self.win.addstr(element[0], element[1])
            except:
                pass
            
